using System;
using System.Messaging;
using System.Threading;

public class MQReceive {
    public static void Main(String[] args) 
    {
        string appName = Environment.GetCommandLineArgs()[0];

        if ( args.Length != 1 ) {
            Console.WriteLine("Usage: " + appName +" <queue>");
            return;
        }

        string mqPath = ".\\" + args[0];

        if ( !MessageQueue.Exists(mqPath) ) {
            Console.WriteLine("The queue '" + mqPath + "' does not exist!");
            return;
        }

        MessageQueue mq = new MessageQueue(mqPath);
        mq.AddOnReceiveCompleted(new ReceiveCompletedEventHandler(OnReceiveCompleted));
        mq.BeginReceive();

        Console.WriteLine("Press \'q\' and Enter to quit the sample");    
        while ( Console.Read()!='q' ) {
            Thread.Sleep(500);  
        }
    }

    public static void OnReceiveCompleted(Object source, ReceiveAsyncEventArgs asyncResult){
        MessageQueue mq = (MessageQueue)source;
        Message m = mq.EndReceive(asyncResult.AsyncResult);
        Console.WriteLine("Message: " + (string)m.Body);    
        mq.BeginReceive();
    }
}